---
feature_story: FS_46_96_59_05
feature_title: propagated implicit values
feature_status: TEST
---
TODO: This is `context_control` (analogy to `search_control`) feature.
      But what it actually specifies is more of `init_control`.
      It should be implemented via `PluginType.InvocatorPlugin` by providing
      a way to assign some `ArgSource.ComputedValue`.

`args_context` is new for each command `line_section`.

In order to narrow down the search for the next `data_envelope` quickly,
some (arg type, arg value) pairs from prev `args_context` can be propagated as `ArgSource.ImplicitValue`-s
into the next `arg_context`.

There are aspects to maintain `ArgSource.ImplicitValue`-s:

*   This feature `FS_62_25_92_06` to propagate values for the next `data_envelope` as initial `args_context`:

    Some of these (arg type, arg value) pairs from previously found `data_envelope`
    should provide necessary (initial) `args_context` for the next `data_envelope` to find.

    TODO: Who decides what goes into `context_control`: config, data, plugin? Probably all.
          However, current solution is to simply use data - see `context_control` key (`DataEnvelopeSchema`)
          which specifies what arg types will be set by the (given) prev `data_envelope` into the next one.
    TODO: Instead of each individual `data_envelope` instance, propagation should be implemented by the plugin
          implementing the function - the most flexible yet clear approach (because only function knows that
          is being searched for).

*   For arg values singled out by the search for the current `data_envelope`, see `FS_13_51_07_97`.

