---
feature_story: FS_82_35_57_62
feature_title: envelope relationship data design
feature_status: TBD
---

For example, consider "is owned by" relationship between `data_envelope` classes:
a `ServiceEnvelopeClass.ClassCluster` has many `ServiceEnvelopeClass.ClassHost`-s.

When `data_envelope`-s has an "is owned by" relationship (or the like) with another, there are two approaches:

*   A: propagate all arg types:

    `ClassHost` is indexed by all:

    *   `ServiceArgType.CodeMaturity`
    *   `ServiceArgType.GeoRegion`
    *   `ServiceArgType.FlowStage`
    *   `ServiceArgType.ClusterName`

*   B: propagate arg type of id only:

    `ClassHost` is indexed by `ServiceArgType.ClusterName` only.

    In this case, these arg types are useless to search `ClassHost`:

    *   `ServiceArgType.CodeMaturity`
    *   `ServiceArgType.GeoRegion`
    *   `ServiceArgType.FlowStage`

   `ClassHost` `data_envelope` simply cannot be found, it requires `ServiceArgType.ClusterName`.

Comparison:

| A: propagate all | B: propagate id only                                                                                 |
|------------------|------------------------------------------------------------------------------------------------------|
| no limitation    | no `ClassHost` can be found until `ClassCluster` is found first                                      |
| no limitation    | functions requiring `ClassHost` has to include search for `ClassCluster`                             |
| no limitation    | narrowing down is not possible (one or none) as `ClassHost` is indexed by exact unique `ClusterName` |