---
test_data: TD_63_37_05_36
test_title: default service data
---

This data is what `ServiceLoader` uses for `relay_demo`.

There is no purpose to cover all special cases (other `test_data` is supposed to cover that) -
the intention is to provide enough data to play with (without overwhelming manual maintenance).

It permutes arg values for arg types defined in `ServiceArgType`:

*   `CodeMaturity`:

    *   `dev`
    *   `qa`
    *   `prod`
  
*   `GeoRegion`:

    *   `apac`
    *   `emea`
    *   `amer`

*   `FlowStage`:

    *   `upstream`
    *   `downstream`

*   `ClusterName`:

    These arg values are composite ids with `${CodeMaturity}-${GeoRegion}-${FlowStage}` format. 

*   `HostName`:

    See table below.

    Each `HostName` has prefix - a random set of letters (used to demo completion by prefix).

    Each `HostName` contains suffix = the first letters of `${CodeMaturity}` and `${FlowStage}`, for example:

    ```
    dev downstream    ->   dd
    qa downstream     ->   qd
    prod upstream     ->   pu
    ```

*   `ServiceName`:

    All `ServiceName` are arbitrary and can be repeated across different `ClusterName`.

    See table below.

Table:

| `CodeMaturity` | `GeoRegion` | `FlowStage`  | `ClusterName`          | `HostName`   | `ServiceName` | is_populated     | comment                          |
|----------------|-------------|--------------|------------------------|--------------|---------------|------------------|----------------------------------|
| -------------- | ----------- | ------------ | ---------------------- | ------------ | ------------- | ---------------- | `dev` is everywhere but limited  |
| `dev`          | `apac`      | `upstream`   | `dev-apac-upstream`    | `zxcv-du`    | `s_a`         | N                |                                  |
| `dev`          | `apac`      | `upstream`   | `dev-apac-upstream`    | `zxcv-du`    | `s_b`         | N                |                                  |
| `dev`          | `apac`      | `upstream`   | `dev-apac-upstream`    | `zxcv-du`    | `s_c`         | Y                |                                  |
|                |             | ------------ | ---------------------- | ------------ | ------------- | ---------------- |                                  |
| `dev`          | `apac`      | `downstream` | `dev-apac-downstream`  | `zxcv-dd`    | `tt`          | N                |                                  |
| `dev`          | `apac`      | `downstream` | `dev-apac-downstream`  | `poiu-dd`    | `xx`          | N                |                                  |
|                | ----------- | ------------ | ---------------------- | ------------ | ------------- | ---------------- | `emea` has no `s_c`              |
| `dev`          | `emea`      | `upstream`   | `dev-emea-upstream`    | `asdf-du`    | `s_a`         | N                |                                  |
| `dev`          | `emea`      | `upstream`   | `dev-emea-upstream`    | `asdf-du`    | `s_b`         | Y                |                                  |
|                |             | ------------ | ---------------------- | ------------ | ------------- | ---------------- |                                  |
| `dev`          | `emea`      | `downstream` | `dev-emea-downstream`  | `xcvb-dd`    | `xx`          | Y                |                                  |
| `dev`          | `emea`      | `downstream` | `dev-emea-downstream`  | `xcvb-dd`    | `zz`          | N                |                                  |
|                | ----------- | ------------ | ---------------------- | ------------ | ------------- |                  | `amer` has only `dev` `upstream` |
| `dev`          | `amer`      | `upstream`   | `dev-amer-upstream`    | `qwer-du`    | `s_a`         | Y                | `amer` has only `s_a` service    |
| -------------- | ----------- | ------------ | ---------------------- | ------------ | ------------- | ---------------- |                                  |
| `qa`           | `apac`      | `upstream`   | `qa-apac-upstream`     | ?            | `s_a`         | N                |                                  |
| `qa`           | `apac`      | `upstream`   | `qa-apac-upstream`     | ?            | `s_b`         | N                |                                  |
| `qa`           | `apac`      | `upstream`   | `qa-apac-upstream`     | `poiu-qu`    | `s_c`         | Y                |                                  |
|                | ----------- | ------------ | ---------------------- | ------------ | ------------- | ---------------- |                                  |
| `qa`           | `emea`      |              |                        |              |               |                  | no `qa` in `emea`                |
|                | ----------- | ------------ | ---------------------- | ------------ | ------------- | ---------------- |                                  |
| `qa`           | `amer`      | `upstream`   | `qa-amer-downstream`   | ?            |               | N                |                                  |
| `qa`           | `amer`      | `upstream`   | `qa-amer-downstream`   | ?            |               | N                |                                  |
|                |             | ------------ | ---------------------- | ------------ | ------------- | ---------------- |                                  |
| `qa`           | `amer`      | `downstream` | `qa-amer-downstream`   | `sdfgh-qd`   |               | N                |                                  |
| `qa`           | `amer`      | `downstream` | `qa-amer-downstream`   | `sdfgb-qd`   |               | N                |                                  |
| `qa`           | `amer`      | `downstream` | `qa-amer-downstream`   | `sdfg-qd`    |               | Y                | host `sdfg-qd` has no services   |
| -------------- | ----------- | ------------ | ---------------------- | ------------ | ------------- | ---------------- | `prod` is only in `apac`         |
| `prod`         | `apac`      | `upstream`   | `prod-apac-upstream`   | `qwer-pd-1`  | `s_a`         | N                |                                  |
| `prod`         | `apac`      | `upstream`   | `prod-apac-upstream`   | `qwer-pd-1`  | `s_b`         | N                |                                  |
| `prod`         | `apac`      | `upstream`   | `prod-apac-upstream`   | `qwer-pd-1`  | `s_c`         | N                |                                  |
| `prod`         | `apac`      | `upstream`   | `prod-apac-upstream`   | `qwer-pd-2`  | `s_a`         | N                |                                  |
| `prod`         | `apac`      | `upstream`   | `prod-apac-upstream`   | `qwer-pd-2`  | `s_b`         | N                |                                  |
| `prod`         | `apac`      | `upstream`   | `prod-apac-upstream`   | `qwer-pd-2`  | `s_c`         | N                |                                  |
|                | ----------- | ------------ | ---------------------- | ------------ | ------------- | ---------------- |                                  |
| `prod`         | `apac`      | `downstream` | `prod-apac-downstream` | `wert-pd-1`  | `tt1`         | Y                |                                  |
| `prod`         | `apac`      | `downstream` | `prod-apac-downstream` | `wert-pd-2`  | `tt2`         | Y                |                                  |
| `prod`         | `apac`      | `downstream` | `prod-apac-downstream` | `wert-pd-2`  | `xx`          | N                |                                  |
| -------------- | ----------- | ------------ | ---------------------- | ------------ | ------------- | ---------------- | ------------------------------   |
|                |             |              |                        |              |               |                  |                                  |
